diff --git a/lib/ethdev/ethdev_trace_points.c b/lib/ethdev/ethdev_trace_points.c
index 165be941a1..4fe1b10979 100644
--- a/lib/ethdev/ethdev_trace_points.c
+++ b/lib/ethdev/ethdev_trace_points.c
@@ -581,3 +581,60 @@ RTE_TRACE_POINT_REGISTER(rte_flow_trace_async_action_handle_destroy,
 
 RTE_TRACE_POINT_REGISTER(rte_flow_trace_async_action_handle_update,
 	lib.ethdev.flow.async_action_handle_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_capabilities_get,
+	lib.ethdev.mtr.capabilities_get)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_create,
+	lib.ethdev.mtr.create)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_destroy,
+	lib.ethdev.mtr.destroy)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_disable,
+	lib.ethdev.mtr.meter_disable)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_dscp_table_update,
+	lib.ethdev.mtr.meter_dscp_table_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_enable,
+	lib.ethdev.mtr.meter_enable)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_profile_add,
+	lib.ethdev.mtr.meter_profile_add)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_profile_delete,
+	lib.ethdev.mtr.meter_profile_delete)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_profile_update,
+	lib.ethdev.mtr.meter_profile_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_stats_read,
+	lib.ethdev.mtr.stats_read)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_stats_update,
+	lib.ethdev.mtr.stats_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_policy_add,
+	lib.ethdev.mtr.meter_policy_add)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_policy_delete,
+	lib.ethdev.mtr.meter_policy_delete)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_policy_update,
+	lib.ethdev.mtr.meter_policy_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_policy_validate,
+	lib.ethdev.mtr.meter_policy_validate)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_meter_vlan_table_update,
+	lib.ethdev.mtr.meter_vlan_table_update)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_color_in_protocol_get,
+	lib.ethdev.mtr.color_in_protocol_get)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_color_in_protocol_priority_get,
+	lib.ethdev.mtr.color_in_protocol_priority_get)
+
+RTE_TRACE_POINT_REGISTER(rte_mtr_trace_color_in_protocol_set,
+	lib.ethdev.mtr.color_in_protocol_set)
diff --git a/lib/ethdev/rte_ethdev_trace.h b/lib/ethdev/rte_ethdev_trace.h
index d3b514372a..15d541ac0b 100644
--- a/lib/ethdev/rte_ethdev_trace.h
+++ b/lib/ethdev/rte_ethdev_trace.h
@@ -18,6 +18,7 @@ extern "C" {
 #include <rte_trace_point.h>
 
 #include "rte_ethdev.h"
+#include "rte_mtr.h"
 
 RTE_TRACE_POINT(
 	rte_ethdev_trace_configure,
@@ -1691,6 +1692,181 @@ RTE_TRACE_POINT(
 	rte_trace_point_emit_int(ret);
 )
 
+RTE_TRACE_POINT(
+	rte_mtr_trace_capabilities_get,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id,
+		struct rte_mtr_capabilities *cap),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_ptr(cap);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_create,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		struct rte_mtr_params *params, int shared),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_ptr(params);
+	rte_trace_point_emit_u32(params->meter_profile_id);
+	rte_trace_point_emit_int(params->use_prev_mtr_color);
+	rte_trace_point_emit_int(params->meter_enable);
+	rte_trace_point_emit_u64(params->stats_mask);
+	rte_trace_point_emit_u32(params->meter_policy_id);
+	rte_trace_point_emit_int(params->default_input_color);
+	rte_trace_point_emit_int(shared);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_destroy,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_disable,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_dscp_table_update,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		enum rte_color *dscp_table),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_ptr(dscp_table);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_enable,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_profile_add,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id,
+		uint32_t meter_profile_id,
+		struct rte_mtr_meter_profile *profile),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(meter_profile_id);
+	rte_trace_point_emit_int(profile->alg);
+	rte_trace_point_emit_int(profile->packet_mode);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_profile_delete,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id,
+		uint32_t meter_profile_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(meter_profile_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_profile_update,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		uint32_t meter_profile_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_u32(meter_profile_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_stats_read,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		struct rte_mtr_stats *stats, uint64_t *stats_mask,
+		int clear),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_ptr(stats);
+	rte_trace_point_emit_ptr(stats_mask);
+	rte_trace_point_emit_int(clear);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_stats_update,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		uint64_t stats_mask),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_u64(stats_mask);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_policy_add,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t policy_id,
+		const struct rte_flow_action *actions),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(policy_id);
+	rte_trace_point_emit_ptr(actions);
+	rte_trace_point_emit_int(actions->type);
+	rte_trace_point_emit_ptr(actions->conf);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_policy_delete,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t policy_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(policy_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_policy_update,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		uint32_t meter_policy_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_u32(meter_policy_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_policy_validate,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id,
+		const struct rte_flow_action *actions),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_ptr(actions);
+	rte_trace_point_emit_int(actions->type);
+	rte_trace_point_emit_ptr(actions->conf);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_meter_vlan_table_update,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		enum rte_color *vlan_table),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_ptr(vlan_table);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_color_in_protocol_get,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_color_in_protocol_priority_get,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		enum rte_mtr_color_in_protocol proto),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_int(proto);
+)
+
+RTE_TRACE_POINT(
+	rte_mtr_trace_color_in_protocol_set,
+	RTE_TRACE_POINT_ARGS(uint16_t port_id, uint32_t mtr_id,
+		enum rte_mtr_color_in_protocol proto, uint32_t priority),
+	rte_trace_point_emit_u16(port_id);
+	rte_trace_point_emit_u32(mtr_id);
+	rte_trace_point_emit_int(proto);
+	rte_trace_point_emit_u32(priority);
+)
+
 #ifdef __cplusplus
 }
 #endif
diff --git a/lib/ethdev/rte_mtr.c b/lib/ethdev/rte_mtr.c
index c460e4f4e0..ff7265cd21 100644
--- a/lib/ethdev/rte_mtr.c
+++ b/lib/ethdev/rte_mtr.c
@@ -6,6 +6,7 @@
 
 #include <rte_errno.h>
 #include "rte_ethdev.h"
+#include "rte_ethdev_trace.h"
 #include "rte_mtr_driver.h"
 #include "rte_mtr.h"
 
@@ -63,6 +64,7 @@ rte_mtr_capabilities_get(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_capabilities_get(port_id, cap);
 	return RTE_MTR_FUNC(port_id, capabilities_get)(dev,
 		cap, error);
 }
@@ -75,6 +77,7 @@ rte_mtr_meter_profile_add(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_profile_add(port_id, meter_profile_id, profile);
 	return RTE_MTR_FUNC(port_id, meter_profile_add)(dev,
 		meter_profile_id, profile, error);
 }
@@ -86,6 +89,7 @@ rte_mtr_meter_profile_delete(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_profile_delete(port_id, meter_profile_id);
 	return RTE_MTR_FUNC(port_id, meter_profile_delete)(dev,
 		meter_profile_id, error);
 }
@@ -97,6 +101,10 @@ rte_mtr_meter_policy_validate(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	int i;
+
+	for (i = 0; i < RTE_COLORS; i++)
+		rte_mtr_trace_meter_policy_validate(port_id, policy->actions[i]);
 	return RTE_MTR_FUNC(port_id, meter_policy_validate)(dev,
 		policy, error);
 }
@@ -109,6 +117,11 @@ rte_mtr_meter_policy_add(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	int i;
+
+	for (i = 0; i < RTE_COLORS; i++)
+		rte_mtr_trace_meter_policy_add(port_id, policy_id,
+					       policy->actions[i]);
 	return RTE_MTR_FUNC(port_id, meter_policy_add)(dev,
 		policy_id, policy, error);
 }
@@ -120,6 +133,7 @@ rte_mtr_meter_policy_delete(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_policy_delete(port_id, policy_id);
 	return RTE_MTR_FUNC(port_id, meter_policy_delete)(dev,
 		policy_id, error);
 }
@@ -133,6 +147,7 @@ rte_mtr_create(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_create(port_id, mtr_id, params, shared);
 	return RTE_MTR_FUNC(port_id, create)(dev,
 		mtr_id, params, shared, error);
 }
@@ -144,6 +159,7 @@ rte_mtr_destroy(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_destroy(port_id, mtr_id);
 	return RTE_MTR_FUNC(port_id, destroy)(dev,
 		mtr_id, error);
 }
@@ -155,6 +171,7 @@ rte_mtr_meter_enable(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_enable(port_id, mtr_id);
 	return RTE_MTR_FUNC(port_id, meter_enable)(dev,
 		mtr_id, error);
 }
@@ -166,6 +183,7 @@ rte_mtr_meter_disable(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_disable(port_id, mtr_id);
 	return RTE_MTR_FUNC(port_id, meter_disable)(dev,
 		mtr_id, error);
 }
@@ -178,6 +196,7 @@ rte_mtr_meter_profile_update(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_profile_update(port_id, mtr_id, meter_profile_id);
 	return RTE_MTR_FUNC(port_id, meter_profile_update)(dev,
 		mtr_id, meter_profile_id, error);
 }
@@ -190,6 +209,7 @@ rte_mtr_meter_policy_update(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_policy_update(port_id, mtr_id, meter_policy_id);
 	return RTE_MTR_FUNC(port_id, meter_policy_update)(dev,
 		mtr_id, meter_policy_id, error);
 }
@@ -202,6 +222,7 @@ rte_mtr_meter_dscp_table_update(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_dscp_table_update(port_id, mtr_id, dscp_table);
 	return RTE_MTR_FUNC(port_id, meter_dscp_table_update)(dev,
 		mtr_id, dscp_table, error);
 }
@@ -214,6 +235,7 @@ rte_mtr_meter_vlan_table_update(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_meter_vlan_table_update(port_id, mtr_id, vlan_table);
 	return RTE_MTR_FUNC(port_id, meter_vlan_table_update)(dev,
 		mtr_id, vlan_table, error);
 }
@@ -227,6 +249,7 @@ rte_mtr_color_in_protocol_set(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_color_in_protocol_set(port_id, mtr_id, proto, priority);
 	return RTE_MTR_FUNC(port_id, in_proto_set)(dev,
 		mtr_id, proto, priority, error);
 }
@@ -239,6 +262,7 @@ rte_mtr_color_in_protocol_get(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_color_in_protocol_get(port_id, mtr_id);
 	return RTE_MTR_FUNC(port_id, in_proto_get)(dev,
 		mtr_id, proto_mask, error);
 }
@@ -252,6 +276,7 @@ rte_mtr_color_in_protocol_priority_get(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_color_in_protocol_priority_get(port_id, mtr_id, proto);
 	return RTE_MTR_FUNC(port_id, in_proto_prio_get)(dev,
 		mtr_id, proto, priority, error);
 }
@@ -264,6 +289,7 @@ rte_mtr_stats_update(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_stats_update(port_id, mtr_id, stats_mask);
 	return RTE_MTR_FUNC(port_id, stats_update)(dev,
 		mtr_id, stats_mask, error);
 }
@@ -278,6 +304,7 @@ rte_mtr_stats_read(uint16_t port_id,
 	struct rte_mtr_error *error)
 {
 	struct rte_eth_dev *dev = &rte_eth_devices[port_id];
+	rte_mtr_trace_stats_read(port_id, mtr_id, stats, stats_mask, clear);
 	return RTE_MTR_FUNC(port_id, stats_read)(dev,
 		mtr_id, stats, stats_mask, clear, error);
 }
diff --git a/lib/ethdev/version.map b/lib/ethdev/version.map
index 5aab81dcbd..767dbfebc5 100644
--- a/lib/ethdev/version.map
+++ b/lib/ethdev/version.map
@@ -471,6 +471,25 @@ EXPERIMENTAL {
 	__rte_flow_trace_tunnel_item_release;
 	__rte_flow_trace_tunnel_match;
 	__rte_flow_trace_validate;
+	__rte_mtr_trace_capabilities_get;
+	__rte_mtr_trace_color_in_protocol_get;
+	__rte_mtr_trace_color_in_protocol_priority_get;
+	__rte_mtr_trace_color_in_protocol_set;
+	__rte_mtr_trace_create;
+	__rte_mtr_trace_destroy;
+	__rte_mtr_trace_meter_disable;
+	__rte_mtr_trace_meter_dscp_table_update;
+	__rte_mtr_trace_meter_enable;
+	__rte_mtr_trace_meter_policy_add;
+	__rte_mtr_trace_meter_policy_delete;
+	__rte_mtr_trace_meter_policy_update;
+	__rte_mtr_trace_meter_policy_validate;
+	__rte_mtr_trace_meter_profile_add;
+	__rte_mtr_trace_meter_profile_delete;
+	__rte_mtr_trace_meter_profile_update;
+	__rte_mtr_trace_meter_vlan_table_update;
+	__rte_mtr_trace_stats_read;
+	__rte_mtr_trace_stats_update;
 };
 
 INTERNAL {